# NativeScript UI AutoComplete

- [Overview](#overview)
- [Installation](#installation)
- [Documentation](#documentation)
- [API Reference](#api-reference)
- [Sample Apps](#sample-apps)
- [Release Notes](#release-notes)
- [Get Help](#get-help)


## Overview

Here are some of the features of the **NativeScript UI AutoComplete**:

* Suggest modes - you can choose to show suggestions in a drop-down list, one suggestion at a time in the text input, or a combination of both;
* Completion modes - StartsWith and Contains which differ in whether the input text will be searched in the whole list with acceptable items or only at the start;
* Display modes - Plain - in which only one item can be selected - and Tokens - allowing multiple selection of suggestions (each displayed as a token).

## Installation

In Command prompt / Terminal navigate to your application root folder and run:

```
tns plugin add nativescript-ui-autocomplete
```

## Documentation

To use the autocomplete plugin, you need to add an instance of `RadAutoCompleteTextView`.
Optionally you can set its `displayMode`, `completionMode` and `suggestMode`.
More information about the plugin features is available in the Guides for:
- [NativeScript Core](https://docs.nativescript.org/ui/professional-ui-components/AutoCompleteTextView/overview) 
- [NativeScript with Angular](https://docs.nativescript.org/angular/ui/professional-ui-components/ng-AutoCompleteTextView/overview)
- [NativeScript with Vue.js](https://docs.nativescript.org/vuejs/ns-ui/AutoCompleteTextView/overview)

## API Reference

[Here](https://docs.nativescript.org/ns-ui-api-reference/classes/radautocompletetextview) is the API Reference section.

## Sample Apps

The features of the plugin are demonstrated in the Sample apps for:
- [NativeScript Core](https://github.com/NativeScript/nativescript-ui-samples)
- [NativeScript with Angular](https://github.com/NativeScript/nativescript-ui-samples-angular)
- [NativeScript with Vue.js](https://github.com/NativeScript/nativescript-ui-samples-vue)

## Release Notes

The release notes are available [here](https://github.com/NativeScript/nativescript-ui-feedback/blob/master/releases/autocomplete.md).

## Get Help

Please, use [github issues](https://github.com/NativeScript/nativescript-ui-feedback/issues) strictly for reporting bugs or requesting features.
