import { ElementRef, TemplateRef, EmbeddedViewRef, ViewContainerRef, OnInit, EventEmitter } from '@angular/core';
import { RadAutoCompleteTextView, SuggestionView, CollectionViewEventData } from 'nativescript-ui-autocomplete';
import { View } from '@nativescript/core';
import * as i0 from "@angular/core";
export declare class ListItemContext extends ElementRef {
    $implicit?: any;
    item?: any;
    index?: number;
    even?: boolean;
    odd?: boolean;
    constructor($implicit?: any, item?: any, index?: number, even?: boolean, odd?: boolean);
}
export interface ItemEventArgs {
    object?: any;
    view: EmbeddedViewRef<any>;
    data: any;
    index: number;
    returnValue?: boolean;
    context: any;
}
export declare type RootLocator = (nodes: Array<any>, nestLevel: number) => View;
export declare class RadAutoCompleteTextViewComponent {
    private _elementRef;
    private loader;
    private _autoCompleteTextView;
    private _itemTemplate;
    setupItemView: EventEmitter<ItemEventArgs>;
    constructor(_elementRef: ElementRef, loader: ViewContainerRef);
    get nativeElement(): RadAutoCompleteTextView;
    get autoCompleteTextView(): RadAutoCompleteTextView;
    set itemTemplate(value: TemplateRef<ElementRef>);
    onItemLoading(args: CollectionViewEventData): void;
    setupViewRef(viewRef: EmbeddedViewRef<any>, data: any, index: number): void;
    private detectChangesOnChild;
    static ɵfac: i0.ɵɵFactoryDeclaration<RadAutoCompleteTextViewComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RadAutoCompleteTextViewComponent, "RadAutoCompleteTextView", never, {}, { "setupItemView": "setupItemView"; }, never, never, false>;
}
export declare class TKAutoCompleteSuggestionViewDirective implements OnInit {
    private owner;
    private _elementRef;
    private _suggestionView;
    constructor(owner: RadAutoCompleteTextViewComponent, _elementRef: ElementRef);
    ngOnInit(): void;
    get nativeElement(): SuggestionView;
    get autoCompleteTextView(): SuggestionView;
    static ɵfac: i0.ɵɵFactoryDeclaration<TKAutoCompleteSuggestionViewDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TKAutoCompleteSuggestionViewDirective, "[tkAutoCompleteSuggestionView]", never, {}, {}, never, never, false>;
}
export declare class TKSuggestionItemTemplateDirective {
    private owner;
    private template;
    constructor(owner: RadAutoCompleteTextViewComponent, template: TemplateRef<any>);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TKSuggestionItemTemplateDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TKSuggestionItemTemplateDirective, "[tkSuggestionItemTemplate]", never, {}, {}, never, never, false>;
}
export declare const AUTOCOMPLETETEXTVIEW_DIRECTIVES: (typeof RadAutoCompleteTextViewComponent | typeof TKAutoCompleteSuggestionViewDirective | typeof TKSuggestionItemTemplateDirective)[];
export declare class NativeScriptUIAutoCompleteTextViewModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NativeScriptUIAutoCompleteTextViewModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NativeScriptUIAutoCompleteTextViewModule, [typeof RadAutoCompleteTextViewComponent, typeof TKAutoCompleteSuggestionViewDirective, typeof TKSuggestionItemTemplateDirective], never, [typeof RadAutoCompleteTextViewComponent, typeof TKAutoCompleteSuggestionViewDirective, typeof TKSuggestionItemTemplateDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NativeScriptUIAutoCompleteTextViewModule>;
}
