import * as commonModule from './common';
export * from './common';
export declare class SuggestionView extends commonModule.SuggestionView {
    private _ios;
    constructor();
    preparingCell: boolean;
    get ios(): TKSuggestionListView;
    set ios(value: TKSuggestionListView);
    createNativeView(): Object;
    updateView(): void;
    private updateHeight;
    private updateTemplate;
    protected onSuggestionViewHeightChanged(oldValue: number, newValue: number): void;
    protected onSuggestionItemTemplateChanged(oldValue: string, newValue: string): void;
}
export declare class TokenModel extends commonModule.TokenModel {
    private _ios;
    constructor(text: string, image: any);
    get ios(): TKAutoCompleteToken;
}
export declare class RadAutoCompleteTextView extends commonModule.RadAutoCompleteTextView {
    private _dataSource;
    private _suggestionViewDataSource;
    private _delegate;
    asyncCall: any;
    _ios: TKAutoCompleteTextView;
    _filteredItems: Array<TokenModel>;
    _selectedTokens: Array<TokenModel>;
    private _clearButton;
    private _noResultsLabel;
    createNativeView(): TKAutoCompleteTextView;
    disposeNativeView(): void;
    resetAutoComplete(): void;
    get clearButton(): ClearButton;
    get noResultsLabel(): NoResultsLabel;
    get filteredItems(): Array<TokenModel>;
    get selectedTokens(): Array<TokenModel>;
    addToken(token: TokenModel): void;
    insertTokenAtIndex(token: TokenModel, index: number): void;
    removeToken(token: TokenModel): void;
    removeTokenAtIndex(index: number): void;
    removeAllTokens(): void;
    tokens(): () => NSArray<any>;
    tokenAtIndex(index: number): TKAutoCompleteToken;
    findSuggestions(): void;
    tokenModelWithText(text: string): commonModule.TokenModel;
    private adjustCompletionMode;
    private adjustDisplayMode;
    private adjustSuggestMode;
    private adjustLayoutMode;
}
export declare class Token extends commonModule.Token {
    private _ios;
    private _clearButton;
    constructor(nativeView: any);
    _updateAutoCompleteTokenSelectedHandlers(subscribe: boolean): void;
    createNativeView(): TKAutoCompleteTokenView;
    disposeNativeView(): void;
    get clearButton(): TokenClearButton;
    eachChild(callback: (child: any) => boolean): void;
}
export declare class NoResultsLabel extends commonModule.NoResultsLabel {
    private _ios;
    constructor(nativeView: any);
    createNativeView(): UILabel;
    disposeNativeView(): void;
}
export declare class ClearButton extends commonModule.ClearButton {
    private _ios;
    private _owner;
    constructor(owner: any);
    createNativeView(): TKAutoCompleteClearButton;
    disposeNativeView(): void;
}
export declare class TokenClearButton extends commonModule.TokenClearButton {
    private _ios;
    private _token;
    constructor(token: TKAutoCompleteTokenView);
    createNativeView(): TKAutoCompleteTokenRemoveButton;
    disposeNativeView(): void;
}
